Hooks:PostHook(WeaponFactoryTweakData, "create_bonuses", "CUFCWMod_Groceries_Init", function(self)

-----------! > Primary < !-----------

	---- Assault Rifles ----
	
	--- LK-05 Carbine ---
if self.wpn_fps_ass_lkrifle then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_lkrifle",
			"bm_w_lkrifle",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"lkrifle_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_upg_gl_m203", "wpn_fps_ass_lkrifle_vg_smol" )
		self:cufcw_setup_forbid( "wpn_fps_upg_gl_m203", "wpn_fps_ass_lkrifle_vg_ergo" )
		self:cufcw_setup_forbid( "wpn_fps_upg_gl_m203", "wpn_fps_ass_lkrifle_vg_mallninja" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_lkrifle",
			"bm_w_lkrifle",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"lkrifle_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ubs_spas12", "wpn_fps_ass_lkrifle_vg_smol" )
		self:cufcw_setup_forbid( "wpn_fps_ubs_spas12", "wpn_fps_ass_lkrifle_vg_ergo" )
		self:cufcw_setup_forbid( "wpn_fps_ubs_spas12", "wpn_fps_ass_lkrifle_vg_mallninja" )
		self:cufcw_check_override( "part", "wpn_fps_ubs_spas12" )
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_ass_lkrifle_vg_standard = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_lkrifle",
			"bm_w_lkrifle",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"lkrifle_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ubs_six12", "wpn_fps_ass_lkrifle_vg_smol" )
		self:cufcw_setup_forbid( "wpn_fps_ubs_six12", "wpn_fps_ass_lkrifle_vg_ergo" )
		self:cufcw_setup_forbid( "wpn_fps_ubs_six12", "wpn_fps_ass_lkrifle_vg_mallninja" )
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_ass_lkrifle_vg_standard = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
end

	--- SG552 ---
if self.wpn_fps_ass_sg552 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_sg552",
			"bm_w_sg552",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"sg552_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_s552_fg_standard", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_ass_sg552_fg_large", "wpn_fps_upg_gl_m203" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_sg552",
			"bm_w_sg552",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"sg552_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_s552_fg_standard", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_ass_sg552_fg_large", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_sg552",
			"bm_w_sg552",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"sg552_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_s552_fg_standard", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_ass_sg552_fg_large", "wpn_fps_ubs_six12" )
	end
end

	--- DDM4 ---
if self.wpn_fps_ass_gcar then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_gcar",
			"bm_w_gcar",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"gcar_gl_cufcw",
			{
				translation = Vector3(-3.35, 0, -9.3),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_gcar_vg_ergo", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_ass_gcar_vg_simple", "wpn_fps_upg_gl_m203" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_gcar",
			"bm_w_gcar",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"gcar_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_gcar_vg_ergo", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_ass_gcar_vg_simple", "wpn_fps_ubs_spas12" )
		self:cufcw_check_override( "part", "wpn_fps_ubs_spas12" )
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_ass_gcar_vg_standard = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_gcar",
			"bm_w_gcar",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"gcar_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_gcar_vg_ergo", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_ass_gcar_vg_simple", "wpn_fps_ubs_six12" )
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_ass_gcar_vg_standard = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
end

	--- ACR ---
if self.wpn_fps_ass_acw then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_acw",
			"bm_w_acw",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"acw_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_acw",
			"bm_w_acw",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"acw_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_acw",
			"bm_w_acw",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"acw_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
end

	
	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----
	
-----------! > Secondary < !-----------

	---- Assault Rifles ----
	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----

	
	--- Scorpion EVO ---
if self.wpn_fps_smg_evo then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_smg_evo",
			"bm_w_evo",
			"wpn_fps_upg_gl_m203",
			"bm_w_m203_secondary",
			"underbarrel_weapons/units/wpn_fps_gl_m203/secondary/short",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"evo_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_stubby", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_new", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_folding", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_mallninja", "wpn_fps_upg_gl_m203" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_smg_evo",
			"bm_w_evo",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12_sec",
			"units/mods/weapons/wpn_fps_ubs_spas12_sec/wpn_fps_ubs_spas12_sec",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"evo_gl_cufcw"
		)
		self:cufcw_check_override( "part", "wpn_fps_smg_schakal_bolt_standard" )
		self.parts.wpn_fps_smg_schakal_bolt_standard.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
		
		self:cufcw_check_override( "part", "wpn_fps_ubs_spas12" )
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_smg_evo_fg_standard = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_stubby", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_new", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_folding", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_mallninja", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_smg_evo",
			"bm_w_evo",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12_sec",
			"units/mods/weapons/wpn_fps_ubs_six12_sec/wpn_fps_ubs_six12_sec",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"evo_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_smg_schakal_bolt_standard" )
		self.parts.wpn_fps_smg_schakal_bolt_standard.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
		
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_smg_evo_fg_standard = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_stubby", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_new", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_folding", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_smg_evo_fg_mallninja", "wpn_fps_ubs_six12" )
	end
end
	
-----------! > Attachments < !-----------

end)