Hooks:PostHook(WeaponFactoryTweakData, "create_bonuses", "CUFCWMod_Killerwolf_Init", function(self)

-----------! > Primary < !-----------

	---- Assault Rifles ----
	
	--- SRSS 7.62 Bulldog ---
if self.wpn_fps_ass_srss762 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_srss762",
			"bm_w_srss762",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"srss_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_srss762",
			"bm_w_srss762",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"srss_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_srss762",
			"bm_w_srss762",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"srss_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
end





	
	
	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----
	
-----------! > Secondary < !-----------

	---- Assault Rifles ----
	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----

-----------! > Attachments < !-----------

	local ubs_list = {
		"wpn_fps_ubs_spas12",
		"wpn_fps_ubs_six12",
		"wpn_fps_upg_gl_m203"
	}
	
	if BeardLib.Utils:FindMod("Gunshield") then
		for i, underbarrel_ids in ipairs(ubs_list) do
			if self[underbarrel_ids] then
				self:SetupForbid( "wpn_fps_shield_v1", underbarrel_ids )
				self:SetupForbid( "wpn_fps_shield_ak", underbarrel_ids )
				self:SetupForbid( "wpn_fps_shield_aug", underbarrel_ids )
				self:SetupForbid( "wpn_fps_shield_dmr", underbarrel_ids )
				self:SetupForbid( "wpn_fps_shield_lr", underbarrel_ids )
				self:SetupForbid( "wpn_fps_shield_bullpup", underbarrel_ids )
				self:SetupForbid( "wpn_fps_shield_shotgun", underbarrel_ids )
				self:SetupForbid( "wpn_fps_shield_lmg", underbarrel_ids )
				self.parts[underbarrel_ids].override.wpn_fps_shield_v2 = {unit = "units/mods/weapons/wpn_fps_shield_pts/wpn_fps_shield_v3"}
				self.parts[underbarrel_ids].override.wpn_fps_shield_m4 = {unit = "units/mods/weapons/wpn_fps_shield_pts/wpn_fps_shield_v4"}
			end
		end
	end
end)