Hooks:PostHook(WeaponFactoryTweakData, "create_bonuses", "CUFCWMod_Nepgearsy_Init", function(self)

-----------! > Primary < !-----------

	---- Assault Rifles ----
	
	--- M27 IAR ---
if self.wpn_fps_ass_m27gear then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_m27gear",
			"bm_w_m27gear",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"m27gear_gl_mp",
			{
				translation = Vector3(-2.3, -6, -10.83),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_upg_gl_m203", "wpn_fps_ass_m27gear_udbr_standard" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_m27gear",
			"bm_w_m27gear",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"m27gear_gl_mp",
			{
				translation = Vector3(-2.3, -6, -10.83),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ubs_spas12", "wpn_fps_ass_m27gear_udbr_standard" )
	end
	
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_m27gear",
			"bm_w_m27gear",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"m27gear_gl_mp",
			{
				translation = Vector3(-2.86, -6, -10.83),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ubs_six12", "wpn_fps_ass_m27gear_udbr_standard" )
	end
end

	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----
	
-----------! > Secondary < !-----------

	---- Assault Rifles ----
	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----

-----------! > Attachments < !-----------

end)