Hooks:PostHook(WeaponFactoryTweakData, "create_bonuses", "CUFCWMod_Pawcio_Init", function(self)

-----------! > Primary < !-----------

	---- Assault Rifles ----
	
	--- HK XM8 ---
if self.wpn_fps_ass_xm8 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_xm8",
			"bm_w_xm8",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"xm8_gl_cufcw",
			{
				translation = Vector3(-1.05, 0, -12.62),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_upg_xm8_handguard_compact", "wpn_fps_upg_gl_m203" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_xm8",
			"bm_w_xm8",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"xm8_gl_cufcw",
			{
				translation = Vector3(-1.05, 0, -12.62),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_upg_xm8_handguard_compact", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_xm8",
			"bm_w_xm8",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"xm8_gl_cufcw",
			{
				translation = Vector3(-1.05, 0, -12.62),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_upg_xm8_handguard_compact", "wpn_fps_ubs_six12" )
	end
end
	--- HK G36K ---
if self.wpn_fps_ass_g36k then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_g36k",
			"bm_w_g36k",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"g36k_gl_cufcw",
			{
				translation = Vector3(-1.05, 0, -12.62),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_g36k_fg_g36c", "wpn_fps_upg_gl_m203" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_g36k",
			"bm_w_g36k",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"g36k_gl_cufcw",
			{
				translation = Vector3(-1.05, 0, -12.62),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_g36k_fg_g36c", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_g36k",
			"bm_w_g36k",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"g36k_gl_cufcw",
			{
				translation = Vector3(-1.05, 0, -12.62),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_g36k_fg_g36c", "wpn_fps_ubs_six12" )
	end
end

	--- Sig SG510 ---
if self.wpn_fps_ass_sg510 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_sg510",
			"bm_w_sg510",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"sg510_gl_cufcw",
			{
				translation = Vector3(-2.3, 2, -13.5),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_sg510",
			"bm_w_sg510",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"sg510_gl_cufcw",
			{
				translation = Vector3(-2.3, 2, -13.5),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "wpn", "wpn_fps_ass_sg510" )
		self.wpn_fps_ass_sg510.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_sg510",
			"bm_w_sg510",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"sg510_gl_cufcw",
			{
				translation = Vector3(-2.3, 2, -13.5),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "wpn", "wpn_fps_ass_sg510" )
		self.wpn_fps_ass_sg510.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
	end
end


	--- IWI Tavor X95 ---
if self.wpn_fps_ass_x95 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_x95",
			"bm_w_x95",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/short",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"x95_gl_cufcw",
			{
				translation = Vector3(-3.65, 0, -13.5),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_upg_gl_m203" )
		self.parts.wpn_fps_upg_gl_m203.override.wpn_fps_ass_x95_vg_tangodown = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_m900", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_lt_fug", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_fab_reg", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_bcm", "wpn_fps_upg_gl_m203" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_x95",
			"bm_w_x95",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"x95_gl_cufcw",
			{
				translation = Vector3(-3.65, 0, -13.5),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_spas12" )
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_ass_x95_vg_tangodown = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_check_override( "part", "wpn_fps_ass_x95_vg_tangodown" )
		self.parts.wpn_fps_ass_x95_vg_tangodown.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_m900", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_lt_fug", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_fab_reg", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_bcm", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_x95",
			"bm_w_x95",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"x95_gl_cufcw",
			{
				translation = Vector3(-3.65, 0, -13.5),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_ass_x95_vg_tangodown = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_check_override( "part", "wpn_fps_ass_x95_vg_tangodown" )
		self.parts.wpn_fps_ass_x95_vg_tangodown.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_m900", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_lt_fug", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_fab_reg", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_x95_vg_bcm", "wpn_fps_ubs_six12" )
	end
end


	--- AK12 ---
if self.wpn_fps_ass_ak12 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_ak12",
			"bm_w_ak12_200",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"ak12_200_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_ak12",
			"bm_w_ak12_200",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"ak12_200_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_ak12",
			"bm_w_ak12_200",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"ak12_200_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
end

	--- Valmet Rk.62 ---
if self.wpn_fps_ass_rk62 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_rk62",
			"bm_w_rk62",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"rk62_gl_cufcw",
			{
				translation = Vector3(-2.6, 4, -14.7),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_rk62_handguard", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_rk62_handguard_rk95", "wpn_fps_upg_gl_m203" )
	end
	--[[    self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_rk62",
			"bm_w_rk62",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"rk62_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_rk62_handguard", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_rk62_handguard_rk95", "wpn_fps_ubs_spas12" )
	end --]]
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_rk62",
			"bm_w_rk62",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"rk62_gl_cufcw",
			{
				translation = Vector3(-2.6, 4, -14.7),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_rk62_handguard", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_rk62_handguard_rk95", "wpn_fps_ubs_six12" )
	end
end


	--- HK416 ---
if self.wpn_fps_ass_hk416 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_hk416",
			"bm_w_hk416",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"hk416_gl_cufcw",
			{
				translation = Vector3(-2.15, -6, -10.83),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_hk416",
			"bm_w_hk416",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"hk416_gl_cufcw",
			{
				translation = Vector3(-2.15, -6, -10.83),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_hk416",
			"bm_w_hk416",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"hk416_gl_cufcw",
			{
				translation = Vector3(-2.15, -6, -10.83),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
end

	--- SCAR-L ---
if self.wpn_fps_ass_scarl then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_scarl",
			"bm_w_scarl",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/normal",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"scarl_gl_cufcw",
			{
				translation = Vector3(-1.65, -6, -10.53),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_upg_scarl_upper_pdw" )
		self.parts.wpn_fps_upg_scarl_upper_pdw.override.wpn_fps_upg_gl_m203 = {unit = "underbarrel_weapons/units/wpn_fps_gl_m203/primary/short"}
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_scarl",
			"bm_w_scarl",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"scarl_gl_cufcw",
			{
				translation = Vector3(-1.65, -6, -10.53),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_upg_scarl_upper_pdw" )
		self.parts.wpn_fps_upg_scarl_upper_pdw.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
	--	self:cufcw_check_override( "wpn", "wpn_fps_ass_scarl" )
	--	self.wpn_fps_ass_scarl.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
	--	self:cufcw_check_override( "part", "wpn_fps_ass_scarl_rec_upper" )
	--	self.wpn_fps_ass_scarl.override.wpn_fps_ass_scarl_rec_upper = {override = {wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail"}}}
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_scarl",
			"bm_w_scarl",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"scarl_gl_cufcw",
			{
				translation = Vector3(-1.65, -6, -10.53),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_upg_scarl_upper_pdw" )
		self.parts.wpn_fps_upg_scarl_upper_pdw.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
	end
end

	--- AKU94 ---
if self.wpn_fps_ass_aku94 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_aku94",
			"bm_w_aku94",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"aku94_gl_cufcw",
			{
				translation = Vector3(-3.05, 2, -8.9),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_upg_gl_m203" )
		self.parts.wpn_fps_upg_gl_m203.override.wpn_fps_ass_aku94_vg_lt_fug = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_check_override( "part", "wpn_fps_ass_aku94_vg_lt_fug" )
		self.parts.wpn_fps_ass_aku94_vg_lt_fug.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_bcm", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_stubby_grip", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_m900", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_fab_reg", "wpn_fps_ubs_spas12" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_aku94",
			"bm_w_aku94",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"aku94_gl_cufcw",
			{
				translation = Vector3(-3.05, 2, -8.9),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_spas12" )
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_ass_aku94_vg_lt_fug = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_check_override( "part", "wpn_fps_ass_aku94_vg_lt_fug" )
		self.parts.wpn_fps_ass_aku94_vg_lt_fug.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_bcm", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_stubby_grip", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_m900", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_fab_reg", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_aku94",
			"bm_w_aku94",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"aku94_gl_cufcw",
			{
				translation = Vector3(-3.05, 2, -8.9),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_ass_aku94_vg_lt_fug = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_check_override( "part", "wpn_fps_ass_aku94_vg_lt_fug" )
		self.parts.wpn_fps_ass_aku94_vg_lt_fug.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_bcm", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_stubby_grip", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_m900", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aku94_vg_fab_reg", "wpn_fps_ubs_six12" )
	end
end

	--- STK SAR 21 MMS ---
if self.wpn_fps_ass_sar21 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_sar21",
			"bm_w_sar21",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"sar21_gl_cufcw",
			{
				translation = Vector3(-3.3, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_upg_gl_m203" )
		self.parts.wpn_fps_upg_gl_m203.override.wpn_fps_ass_sar21_vg_gp033 = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_setup_forbid( "wpn_fps_upg_sar21_vg_m900", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_sar21_vg_fab_reg", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_sar21_vg_bcm", "wpn_fps_upg_gl_m203" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_sar21",
			"bm_w_sar21",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"sar21_gl_cufcw",
			{
				translation = Vector3(-3.3, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_spas12" )
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_ass_sar21_vg_gp033 = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_setup_forbid( "wpn_fps_upg_sar21_vg_m900", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_sar21_vg_fab_reg", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_sar21_vg_bcm", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_sar21",
			"bm_w_sar21",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"sar21_gl_cufcw",
			{
				translation = Vector3(-3.3, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_ass_sar21_vg_gp033 = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_setup_forbid( "wpn_fps_upg_sar21_vg_m900", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_sar21_vg_fab_reg", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_sar21_vg_bcm", "wpn_fps_ubs_six12" )
	end
end


	--- FN FNAR ---
if self.wpn_fps_ass_fnar then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_fnar",
			"bm_w_fnar",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"fnar_gl_cufcw",
			{
				translation = Vector3(-2.6, 4, -14.4),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_upg_fnar_bipod_harris", "wpn_fps_upg_gl_m203" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_fnar",
			"bm_w_fnar",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"fnar_gl_cufcw",
			{
				translation = Vector3(-2.6, 4, -14.4),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ass_fnar_handguard" )
		self.parts.wpn_fps_ass_fnar_handguard.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
		self:cufcw_setup_forbid( "wpn_fps_upg_fnar_bipod_harris", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_fnar",
			"bm_w_fnar",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"fnar_gl_cufcw",
			{
				translation = Vector3(-2.6, 4, -14.4),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ass_fnar_handguard" )
		self.parts.wpn_fps_ass_fnar_handguard.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
		self:cufcw_setup_forbid( "wpn_fps_upg_fnar_bipod_harris", "wpn_fps_ubs_six12" )
	end
end


	--- GALIL ACE 23 ---
if self.wpn_fps_ass_galilace then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_galilace",
			"bm_w_galilace",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"galilace_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_upg_gl_m203" )
		self.parts.wpn_fps_upg_gl_m203.override.wpn_fps_ass_galilace_vg_tangodown = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_m900", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_lt_fug", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_fab_reg", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_bcm", "wpn_fps_ubs_spas12" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_galilace",
			"bm_w_galilace",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"galilace_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_spas12" )
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_ass_galilace_vg_tangodown = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_m900", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_lt_fug", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_fab_reg", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_bcm", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_galilace",
			"bm_w_galilace",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"galilace_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_ass_galilace_vg_tangodown = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_m900", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_lt_fug", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_fab_reg", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_galilace_vg_bcm", "wpn_fps_ubs_six12" )
	end
end

	--- GALIL ACE 52 ---
if self.wpn_fps_ass_galilace_762 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_galilace_762",
			"bm_w_galilace762",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"galilace762_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_galilace_762",
			"bm_w_galilace762",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"galilace762_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_galilace_762",
			"bm_w_galilace762",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"galilace762_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
end

	--[[--- F2000 ---
if self.wpn_fps_ass_f2000 then

	-- M203 Template for Future --
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_f2000",
			"bm_w_f2000",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"f2000_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
end
--]]
	
	--- ASH 12.7 ---
if self.wpn_fps_ass_ash then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_ash",
			"bm_w_ash",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"ash_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_ash",
			"bm_w_ash",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"ash_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_ash",
			"bm_w_ash",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"ash_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
end

	--- Desert Tech MDR ---
if self.wpn_fps_ass_mdr then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_mdr",
			"bm_w_mdr",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"mdr_gl_cufcw",
			{
				translation = Vector3(-3.65, 0, -13.5),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_mdr",
			"bm_w_mdr",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"mdr_gl_cufcw",
			{
				translation = Vector3(-3.65, 0, -13.5),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_spas12" )
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_ass_mdr_vg_tangodown = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_check_override( "part", "wpn_fps_ass_mdr_vg_tangodown" )
		self.parts.wpn_fps_ass_mdr_vg_tangodown.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
		self:cufcw_setup_forbid( "wpn_fps_upg_mdr_vg_bcm", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_mdr_vg_fab_reg", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_mdr_vg_lt_fug", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_mdr_vg_m900", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_mdr",
			"bm_w_mdr",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"mdr_gl_cufcw",
			{
				translation = Vector3(-3.65, 0, -13.5),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_ass_mdr_vg_tangodown = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self:cufcw_check_override( "part", "wpn_fps_ass_mdr_vg_tangodown" )
		self.parts.wpn_fps_ass_mdr_vg_tangodown.override.wpn_fps_ubs_six12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_six12_pts/wpn_fps_ubs_six12_rail_short"}
	end
end


	--- SA vz.58P ---
if self.wpn_fps_ass_vz58 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_vz58",
			"bm_w_vz58",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"vz58_gl_cufcw",
			{
				translation = Vector3(-2.9, 4, -13.6),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_vz58_handguard", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_vz58_handguard_ergo", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_vz58_handguard_black", "wpn_fps_upg_gl_m203" )
	end
	--[[ SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_vz58",
			"bm_w_vz58",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"vz58_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_vz58_handguard", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_vz58_handguard_ergo", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_vz58_handguard_black", "wpn_fps_ubs_spas12" )
	end --]]
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_vz58",
			"bm_w_vz58",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"vz58_gl_cufcw",
			{
				translation = Vector3(-2.9, 4, -13.6),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_vz58_handguard", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_vz58_handguard_ergo", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_vz58_handguard_black", "wpn_fps_ubs_six12" )
	end
end

	---- Akimbos ----
	---- Machine Guns ----
	
	--- STK Ultimax 100 Mark 5 ---
if self.wpn_fps_lmg_ultimax then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_lmg_ultimax",
			"bm_w_ultimax",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"ultimax_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_lmg_ultimax",
			"bm_w_ultimax",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"ultimax_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_lmg_ultimax",
			"bm_w_ultimax",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"ultimax_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
end

	--- AAI LSAT ---
if self.wpn_fps_lmg_lsat then

	--[[ M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_lmg_lsat",
			"bm_w_lsat",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"lsat_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	--]]
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_lmg_lsat",
			"bm_w_lsat",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"lsat_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_spas12" )
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_lmg_lsat_bipod_folded = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_lmg_lsat",
			"bm_w_lsat",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"lsat_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_lmg_lsat_bipod_folded = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
end

	
	---- Pistols / Revolvers ----
	---- Shotuns ----
	
	
	--- AK 12/76 ---
if self.wpn_fps_shot_ak12_76 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_shot_ak12_76",
			"bm_w_ak12_76",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"ak12_76_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_shot_ak12_76",
			"bm_w_ak12_76",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"ak12_76_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_shot_ak12_76",
			"bm_w_ak12_76",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"ak12_76_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
end

	--- Molot Vepr-12 ---
if self.wpn_fps_shot_vepr12 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_shot_vepr12",
			"bm_w_vepr12",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"vepr12_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_shot_vepr12_handguard", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_vepr12_handguard_ak_wood", "wpn_fps_upg_gl_m203" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_shot_vepr12",
			"bm_w_vepr12",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"vepr12_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_shot_vepr12_handguard", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_vepr12_handguard_ak_wood", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_shot_vepr12",
			"bm_w_vepr12",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"vepr12_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_shot_vepr12_handguard", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_vepr12_handguard_ak_wood", "wpn_fps_ubs_six12" )
	end
end

	---- Sniper Rifles ----
	
	
	--- MK12 Mod 1 SPR ---
if self.wpn_fps_snp_mk12 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_snp_mk12",
			"bm_w_mk12",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"mk12_gl_cufcw",
			{
				translation = Vector3(-2.8, -6, -10.83),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_upg_gl_m203" )
		self.parts.wpn_fps_upg_gl_m203.override.wpn_fps_snp_mk12_handguard_railcover = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self.parts.wpn_fps_upg_gl_m203.override.wpn_fps_upg_mk12_handguard_ddm4fsp_railcover = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self.parts.wpn_fps_upg_gl_m203.override.wpn_fps_upg_mk12_handguard_ddmk18_railcover = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_snp_mk12",
			"bm_w_mk12",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"mk12_gl_cufcw",
			{
				translation = Vector3(-2.8, -6, -10.83),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_spas12" )
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_snp_mk12_handguard_railcover = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_upg_mk12_handguard_ddm4fsp_railcover = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_upg_mk12_handguard_ddmk18_railcover = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_snp_mk12",
			"bm_w_mk12",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"mk12_gl_cufcw",
			{
				translation = Vector3(-2.8, -6, -10.83),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_snp_mk12_handguard_railcover = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_upg_mk12_handguard_ddm4fsp_railcover = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_upg_mk12_handguard_ddmk18_railcover = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
end

	--- FD338 ---
if self.wpn_fps_ass_fd338 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_fd338",
			"bm_w_fd338",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"fd338_gl_cufcw",
			{
				translation = Vector3(-2.5, 0, -13.9),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	--[[ SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_fd338",
			"bm_w_fd338",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"fd338_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end --]]
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_fd338",
			"bm_w_fd338",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"fd338_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -12),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
end
	---- Specials ----
	---- Submachine Guns ----
	
-----------! > Secondary < !-----------

	---- Assault Rifles ----
	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----
	
	--- PP-19-01 Vityaz ---
if self.wpn_fps_smg_vityaz then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_smg_vityaz",
			"bm_w_vityaz",
			"wpn_fps_upg_gl_m203",
			"bm_w_m203_secondary",
			"underbarrel_weapons/units/wpn_fps_gl_m203/secondary/short",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"vityaz_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_smg_vityaz_handguard", "wpn_fps_upg_gl_m203" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_smg_vityaz",
			"bm_w_vityaz",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12_sec",
			"units/mods/weapons/wpn_fps_ubs_six12_sec/wpn_fps_ubs_six12_sec",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"vityaz_gl_cufcw",
			{
				translation = Vector3(-2.4, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_smg_vityaz_handguard", "wpn_fps_ubs_six12" )
	end
end

	--- Steyr AUG A3 9mm XS ---
if self.wpn_fps_smg_aug9mm then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_smg_aug9mm",
			"bm_w_aug9mm",
			"wpn_fps_upg_gl_m203",
			"bm_w_m203_secondary",
			"underbarrel_weapons/units/wpn_fps_gl_m203/secondary/short",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"aug9mm_gl_cufcw",
			{
				translation = Vector3(-3.65, 0, -13.5),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_upg_aug9mm_vg_bcm", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aug9mm_vg_fab_reg", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aug9mm_vg_m900", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aug9mm_vg_troy", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aug9mm_vg_troy_short", "wpn_fps_upg_gl_m203" )
		self:cufcw_check_override( "part", "wpn_fps_upg_gl_m203" )
		self.parts.wpn_fps_upg_gl_m203.override.wpn_fps_smg_aug9mm_vg_gp033 = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_smg_aug9mm",
			"bm_w_aug9mm",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12_sec",
			"units/mods/weapons/wpn_fps_ubs_six12_sec/wpn_fps_ubs_six12_sec",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"aug9mm_gl_cufcw",
			{
				translation = Vector3(-3.65, 0, -13.5),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_upg_aug9mm_vg_bcm", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aug9mm_vg_fab_reg", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aug9mm_vg_m900", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aug9mm_vg_troy", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_aug9mm_vg_troy_short", "wpn_fps_ubs_six12" )
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_smg_aug9mm_vg_gp033 = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
end

-----------! > Attachments < !-----------

end)