Hooks:PostHook(WeaponFactoryTweakData, "create_bonuses", "CUFCWMod_Silent_Enforcer_Init", function(self)

-----------! > Primary < !-----------

	---- Assault Rifles ----
	
	--- QBZ95 ---
if self.wpn_fps_ass_qbz95 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_qbz95",
			"bm_w_qbz95",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"qbz95_gl_cufcw",
			{
				translation = Vector3(0, 0, -14),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_upg_gl_m203", "wpn_fps_ass_qbz95_bipod" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_qbz95",
			"bm_w_qbz95",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"qbz95_gl_cufcw",
			{
				translation = Vector3(0, 0, -14),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ubs_spas12", "wpn_fps_ass_qbz95_bipod" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_qbz95",
			"bm_w_qbz95",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"qbz95_gl_cufcw",
			{
				translation = Vector3(0, 0, -14),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ubs_six12", "wpn_fps_ass_qbz95_bipod" )
	end
end





	
	
	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----
	
-----------! > Secondary < !-----------

	---- Assault Rifles ----
	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----
	
	--- Spectre M4 ---
if self.wpn_fps_smg_spectre_m4 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_smg_spectre_m4",
			"bm_w_spectre_m4",
			"wpn_fps_upg_gl_m203",
			"bm_w_m203_secondary",
			"underbarrel_weapons/units/wpn_fps_gl_m203/secondary/short",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"spectre_m4_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_smg_spectre_m4_a_vg", "wpn_fps_upg_gl_m203" )
		self:cufcw_check_override( "part", "wpn_fps_upg_gl_m203" )
		self.parts.wpn_fps_upg_gl_m203.override.wpn_fps_smg_spectre_m4_vg = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
end

-----------! > Attachments < !-----------

end)