Hooks:PostHook( WeaponTweakData, "init", "CUFCWMod_Alcat_Init", function(self)


-- Mini-14
	if self.mini14 then
	self:cufcw_attachment_point( "mini14", {
			name = "a_gl",
			base_a_obj = "a_b",
			position = Vector3(0, -2, -5),
			rotation = Rotation(0, 0, 0)
		}
	)
	self:cufcw_attachment_point( "mini14", {
			name = "a_ubs_spas12",
			base_a_obj = "a_vg",
			position = Vector3(0.4, 13.5, -0.25),
			rotation = Rotation(0, 0, 0)
		}
	)
	self:cufcw_attachment_point( "mini14", {
             name = "a_fl_ubs_spas",
             base_a_obj = "a_fl",
             position = Vector3( -1.6, -5.5, -7.5 ),
             rotation = Rotation( 0, 0, 0 )
		}
	)
	self:cufcw_attachment_point( "mini14", {
             name = "a_fl_ubs_rail",
             base_a_obj = "a_fl",
             position = Vector3( -1.6, -5.5, -7.5 ),
             rotation = Rotation( 0, 0, 0 )
		}
	)
	self:cufcw_attachment_point( "mini14", {
			name = "a_ubs_six12",
			base_a_obj = "a_vg",
			position = Vector3(0.4, 7.5, -1.25),
			rotation = Rotation(0, 0, 0)
		}
	)
	self:cufcw_attachment_point( "mini14", {
             name = "a_fl_ubs_six12",
             base_a_obj = "a_fl",
             position = Vector3( -1.6, -11.5, -7.5 ),
             rotation = Rotation( 0, 0, 0 )
		}
	)
	end


-- MP7 Autopistol
if self.hlmp7 then
	self:cufcw_attachment_point( "hlmp7", {
			name = "a_gl",
			base_a_obj = "a_b",
			position = Vector3(0, 17, -2.8),
			rotation = Rotation(0, 0, 0)
		}
	)
	self:cufcw_attachment_point( "hlmp7", {
			name = "a_ubs_spas12",
			base_a_obj = "a_b",
			position = Vector3(0, 19.4, -4.6),
			rotation = Rotation(0, 0, 0)
	}
	)
	self:cufcw_attachment_point( "hlmp7", {
             name = "a_fl_ubs_spas",
             base_a_obj = "a_b",
             position = Vector3( 0.8, 13.4, -7.8 ),
             rotation = Rotation( 0, 0, 0 )
    }
	)
	self:cufcw_attachment_point( "hlmp7", {
             name = "a_fl_ubs_rail",
             base_a_obj = "a_b",
             position = Vector3( 0.8, 7.2, -7.8 ),
             rotation = Rotation( 0, 0, 0 )
    }
	)
	self:cufcw_attachment_point( "hlmp7", {
			name = "a_ubs_six12",
			base_a_obj = "a_b",
			position = Vector3(0, 13.4, -5.6),
			rotation = Rotation(0, 0, 0)
	}
	)
	self:cufcw_attachment_point( "hlmp7", {
             name = "a_fl_ubs_six12",
             base_a_obj = "a_b",
             position = Vector3( 0.8, 7.4, -7.8 ),
             rotation = Rotation( 0, 0, 0 )
    }
	)
end

-- QBU-88
if self.qbu88 then
	self:cufcw_attachment_point( "qbu88", {
			name = "a_gl",
			base_a_obj = "a_b",
			position = Vector3(0, 19, -3),
			rotation = Rotation(0, 0, 0)
		}
	)
	self:cufcw_attachment_point( "qbu88", {
			name = "a_ubs_spas12",
			base_a_obj = "a_b",
			position = Vector3(0.2, 27.4, -4),
			rotation = Rotation(0, 0, 0)
	}
	)
	self:cufcw_attachment_point( "qbu88", {
             name = "a_fl_ubs_spas",
             base_a_obj = "a_b",
             position = Vector3( 1, 21.4, -7.2),
             rotation = Rotation( 0, 0, 0 )
    }
	)
	self:cufcw_attachment_point( "qbu88", {
             name = "a_fl_ubs_rail",
             base_a_obj = "a_b",
             position = Vector3( 1, 15.2, -6.7),
             rotation = Rotation( 0, 0, 0 )
    }
	)
	self:cufcw_attachment_point( "qbu88", {
			name = "a_ubs_six12",
			base_a_obj = "a_b",
			position = Vector3(0.2, 21.4, -5),
			rotation = Rotation(0, 0, 0)
	}
	)
	self:cufcw_attachment_point( "qbu88", {
             name = "a_fl_ubs_six12",
             base_a_obj = "a_b",
             position = Vector3( 1, 15.4, -7.2),
             rotation = Rotation( 0, 0, 0 )
    }
	)
end

-- MG5
if self.mg5 then
	self:cufcw_attachment_point( "mg5", {
			name = "a_gl",
			base_a_obj = "a_b",
			position = Vector3(0, 17, -7),
			rotation = Rotation(0, 0, 0)
		}
	)
	self:cufcw_attachment_point( "mg5", {
			name = "a_ubs_spas12",
			base_a_obj = "a_b",
			position = Vector3(0.2, 15.4, -9),
			rotation = Rotation(0, 0, 0)
	}
	)
	self:cufcw_attachment_point( "mg5", {
             name = "a_fl_ubs_spas",
             base_a_obj = "a_b",
             position = Vector3( 1, 9.4, -12.2),
             rotation = Rotation( 0, 0, 0 )
    }
	)
	self:cufcw_attachment_point( "mg5", {
             name = "a_fl_ubs_rail",
             base_a_obj = "a_b",
             position = Vector3( 1, 9, -11.7),
             rotation = Rotation( 0, 0, 0 )
    }
	)
	self:cufcw_attachment_point( "mg5", {
			name = "a_ubs_six12",
			base_a_obj = "a_b",
			position = Vector3(0.2, 9.4, -10),
			rotation = Rotation(0, 0, 0)
	}
	)
	self:cufcw_attachment_point( "mg5", {
             name = "a_fl_ubs_six12",
             base_a_obj = "a_b",
             position = Vector3( 1, 3.4, -12.2),
             rotation = Rotation( 0, 0, 0 )
    }
	)
end
	
end )