Hooks:PostHook(WeaponFactoryTweakData, "create_bonuses", "CUFCWMod_Alcat_Init", function(self)

-----------! > Primary < !-----------

	---- Assault Rifles ----
	
	--- Mini-14 ---
if self.wpn_fps_ass_mini14 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_mini14",
			"bm_w_mini14",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"mini14_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_mini14_body_standard", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_ass_mini14_body_gb", "wpn_fps_upg_gl_m203" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_mini14",
			"bm_w_mini14",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"mini14_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_mini14_body_standard", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_ass_mini14_body_gb", "wpn_fps_ubs_spas12" )
	end
	
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_mini14",
			"bm_w_mini14",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"mini14_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_mini14_body_standard", "wpn_fps_ubs_six12" )
		self:cufcw_setup_forbid( "wpn_fps_ass_mini14_body_gb", "wpn_fps_ubs_six12" )
	end
end





	
	
	---- Akimbos ----
	---- Machine Guns ----
	
	
	--- MG5 ---
if self.wpn_fps_lmg_mg5 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_lmg_mg5",
			"bm_w_mg5",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"mg5_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_lmg_mg5_fg_shield", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_lmg_mg5_fg_angled", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_lmg_mg5_fg_straight", "wpn_fps_upg_gl_m203" )
		self:cufcw_setup_forbid( "wpn_fps_upg_bp_lmg_lionbipod", "wpn_fps_upg_gl_m203" )
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_lmg_mg5",
			"bm_w_mg5",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"mg5_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_lmg_mg5_fg_shield", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_lmg_mg5_fg_angled", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_lmg_mg5_fg_straight", "wpn_fps_ubs_spas12" )
		self:cufcw_setup_forbid( "wpn_fps_upg_bp_lmg_lionbipod", "wpn_fps_ubs_spas12" )
		self:cufcw_check_override( "part", "wpn_fps_lmg_mg5_body_upper" )
		self.parts.wpn_fps_lmg_mg5_body_upper.override.wpn_fps_ubs_spas12_rail = {unit = "units/mods/weapons/wpn_fps_ubs_spas12_pts/wpn_fps_ubs_spas12_rail_short"}
		
		-- Six 12 --
		if self.parts.wpn_fps_ubs_six12 then
			self:cufcw_setup_underbarrel( 
				"wpn_fps_lmg_mg5",
				"bm_w_mg5",
				"wpn_fps_ubs_six12",
				"bm_w_ubs_six12",
				"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
				"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
				"mg5_gl_cufcw",
				{
					translation = Vector3(-2.85, 0, -11.07),
					rotation = Rotation(0, 0, -45)
				}
			)
		end
	end
end

	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles / DMRs ----
	
	
	--- QBU-88 ---
if self.wpn_fps_snp_qbu88 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_snp_qbu88",
			"bm_w_qbu88",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"qbu88_gl_cufcw",
			{
				translation = Vector3(-2.2, 0, -9.5),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_snp_qbu88_bipod", "wpn_fps_upg_gl_m203" )
	end
	--[[ nope 
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_snp_qbu88",
			"bm_w_qbu88",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"qbu88_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_snp_qbu88_bipod", "wpn_fps_ubs_spas12" )
	end
	--]]
end

	---- Specials ----
	---- Submachine Guns ----
	
-----------! > Secondary < !-----------

	---- Assault Rifles ----
	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----

	--- MP7 Autopistol ---
if self.wpn_fps_pis_hlmp7 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_pis_hlmp7",
			"bm_w_hlmp7",
			"wpn_fps_upg_gl_m203",
			"bm_w_m203_secondary",
			"underbarrel_weapons/units/wpn_fps_gl_m203/secondary/short",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"hlmp7_gl_cufcw",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "wpn", "wpn_fps_pis_hlmp7")
		self.wpn_fps_pis_hlmp7.override.wpn_fps_upg_gl_m203 = {forbids = {
		"wpn_fps_upg_fl_pis_x400v",
		"wpn_fps_upg_fl_pis_crimson",
		"wpn_fps_upg_fl_pis_laser",
		"wpn_fps_upg_fl_pis_tlr1"
		}}
	end
end

	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----
	
	
-----------! > Attachments < !-----------

end)