Hooks:PostHook(WeaponFactoryTweakData, "create_bonuses", "CUFCWMod_Mira_Init", function(self)

-----------! > Primary < !-----------

	---- Assault Rifles ----
	
	--- SAI GRY ---
if self.wpn_fps_ass_saigry then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_saigry",
			"bm_w_saigry",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"saigry_gl_mp",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_saigry",
			"bm_w_saigry",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"saigry_gl_mp",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_saigry",
			"bm_w_saigry",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"saigry_gl_mp",
			{
				translation = Vector3(-2.85, 0, -11.07),
				rotation = Rotation(0, 0, -45)
			}
		)
	end
end

	--- MSBS ---
if self.wpn_fps_ass_grotb then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_grotb",
			"bm_w_grotb",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"grotb_gl_mp",
			{
				translation = Vector3(-0.9, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_upg_gl_m203" )
		self.parts.wpn_fps_upg_gl_m203.override.wpn_fps_ass_grotb_avg = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_grotb",
			"bm_w_grotb",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"grotb_gl_mp",
			{
				translation = Vector3(-0.9, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_spas12" )
		self.parts.wpn_fps_ubs_spas12.override.wpn_fps_ass_grotb_avg = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_grotb",
			"bm_w_grotb",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"grotb_gl_mp",
			{
				translation = Vector3(-0.9, 0, -13),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_check_override( "part", "wpn_fps_ubs_six12" )
		self.parts.wpn_fps_ubs_six12.override.wpn_fps_ass_grotb_avg = {unit = "units/payday2/weapons/wpn_upg_dummy/wpn_upg_dummy"}
	end
end

	--- HK33 ---
if self.wpn_fps_ass_hk33 then

	-- M203	--
	if self.parts.wpn_fps_upg_gl_m203 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_hk33",
			"bm_w_hk33",
			"wpn_fps_upg_gl_m203",
			"bm_w_contraband_m203",
			"underbarrel_weapons/units/wpn_fps_gl_m203/primary/no_barrel_attach",
			"underbarrel_weapons/objects/wpn_fps_gl_m203/material",
			"hk33_gl_mp",
			{
				translation = Vector3(-1.7, 0, -13.9),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_hk33_fg", "wpn_fps_upg_gl_m203" )
	end
	
	-- SPAS 12 --
	if self.parts.wpn_fps_ubs_spas12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_hk33",
			"bm_w_hk33",
			"wpn_fps_ubs_spas12",
			"bm_w_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"units/mods/weapons/wpn_fps_ubs_spas12/wpn_fps_ubs_spas12",
			"hk33_gl_mp",
			{
				translation = Vector3(-1.7, 0, -13.9),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_hk33_fg", "wpn_fps_ubs_spas12" )
	end
	-- Six 12 --
	if self.parts.wpn_fps_ubs_six12 then
		self:cufcw_setup_underbarrel( 
			"wpn_fps_ass_hk33",
			"bm_w_hk33",
			"wpn_fps_ubs_six12",
			"bm_w_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"units/mods/weapons/wpn_fps_ubs_six12/wpn_fps_ubs_six12",
			"hk33_gl_mp",
			{
				translation = Vector3(-1.7, 0, -13.9),
				rotation = Rotation(0, 0, -45)
			}
		)
		self:cufcw_setup_forbid( "wpn_fps_ass_hk33_fg", "wpn_fps_ubs_six12" )
	end
	
	
end





	
	
	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----
	
-----------! > Secondary < !-----------

	---- Assault Rifles ----
	---- Akimbos ----
	---- Machine Guns ----
	---- Pistols / Revolvers ----
	---- Shotuns ----
	---- Sniper Rifles ----
	---- Specials ----
	---- Submachine Guns ----

-----------! > Attachments < !-----------

end)